package Anvil::Common;

use strict;
use UCW::CGI;
use Email::Address;
use Anvil::User;

our ($set_allrep, $set_allmy, $set_allart, $set_allnew, $set_hidden, $set_pass, $set_pass_check, $set_name); #used in settings.pl
our ($offset); #used in index.pl 
our ($art, $send); #used in read.pl
our ($reply_to, $reply_checkq, $reply_checka, $reply_action, $reply_subject, $reply_name, $reply_email, $reply_text); #used in reply.pl
our ($form_email, $conf_email, $hash, $logout, $form_password);

my %vars = (
        'form_email' => { 'var' => \$form_email, 'default' => '', 'check' =>
                       $Email::Address::addr_spec, 'pass' => 0},
	'conf_email' => { 'var' => \$conf_email, 'default' => '', 'pass' => 0 },
	'hash' => { 'var' => \$hash, 'default' => '', 'pass' => 0 },
	'logout' => {'var' => \$logout, 'default' => 0, 'pass' => 0 },
	'offset' => { 'var' => \$offset, 'default' => 0, check=> '\d+' },
	'art' => { 'var' => \$art, 'default' => '', 'check' => '[A-Za-z0-9_\/-]+'},
	'send' => {'var' => \$send, 'default' => '', 'check' =>
				'\d+', 'pass' => 0},
	'set_allrep' => {'var' => \$set_allrep, 'default' => '', 'pass' => 0},
	'set_allmy' => {'var' => \$set_allmy, 'default' => '', 'pass' => 0},
	'set_allart' => {'var' => \$set_allart, 'default' => '', 'pass' => 0},
	'set_allnew' => {'var' => \$set_allnew, 'default' => '', 'pass' => 0},
	'set_hidden' => {'var' => \$set_hidden, 'default' => 0, 'check' => '[01]','pass' => 0},
	'set_pass' => {'var' => \$set_pass, default => '', 'pass' => 0},
	'set_pass_check' => {'var' => \$set_pass_check, default => '', 'pass' => 0},
	'set_name' => {'var' => \$set_name, default => '', 'pass' => 0},
	'reply_to' => {'var' => \$reply_to, 'default' => '', 'check' => '\d+', 'pass' => 1},
	'reply_checkq' => {'var' => \$reply_checkq, 'default' => '', 'pass' => 1},
	'reply_checka' => {'var' => \$reply_checka, 'default' => '', 'pass' => 1},
	'reply_action' => {'var' => \$reply_action, 'default' => '', 'pass' => 1},
	'reply_subject' => {'var' => \$reply_subject, 'default' => '', 'pass' => 1},
	'reply_name' => {'var' => \$reply_name, 'default' => '', 'pass' => 1},
	'reply_email' => {'var' => \$reply_email, 'default' => '', 'pass' => 1},
	'reply_text' => {'var' => \$reply_text, 'default' => '', 'multiline' => 1, 'pass' => 1},
	'form_password' => {'var' => \$form_password, 'default' => '', 'pass' => 0}
);

UCW::CGI::parse_args(\%vars) if defined $ENV{"REQUEST_URI"};

sub
print_login_info
{
	if (not defined $Anvil::User::email) {

		print "<div class='login_form'>\n";
		print "<form method ='post' action='", url('login'), "' class='login'>\n";
		print "<div class='lf_row'>";
		print "<span id='fe_label'>E-mail: </span>\n";
		print "<input type='text' name='form_email' class='login'>\n";
		print "</div>\n<div class='lf_row'>\n";
		print "<span id='fp_label'>Heslo: </span>\n";
		print "<input type='password' name='form_password' class='login'>\n";
		print "</div>";
		print "<div class='lf_row'>\n";
		print "<input type='submit' value='Poslat' class='login'>";
		print "</div>\n";
		print "</form>\n";

		print "<a href='", url('read', 'art' => 'help') , "'>Návod k použití</a>\n";

		print "</div>\n";
	} else {
		print "<div class='logged_in'>";
		print $Anvil::User::email." přihlášen<br>\n";
		print "<a href='", url('login', 'logout' => 1), "'>odhlásit</a> | <a href='", url('settings'), "'>nastavení</a>";
		print "</div>";
	}
}

sub
set_login_cookie
{
	UCW::CGI::set_cookie('astfgl', 
			"$Anvil::User::uid;$Anvil::User::email;".
			Anvil::User::get_hash($Anvil::User::uid.
					":".$Anvil::User::email).
			";".UCW::CGI::url_escape($Anvil::User::name), 
			'Max-Age' => '99023040');
}

sub
init
{
	#if cookie is correct, set up user variables and return
	my %cookie = UCW::CGI::parse_cookies();
	if (defined $cookie{'astfgl'}){ #FIXME - delimiter
		my ($cook_id, $cook_email, $cook_hash, $cook_name) = split(/;/, $cookie{'astfgl'});
		return if (not defined $cook_id) or (not defined $cook_email) or (not defined $cook_hash) or (not defined $cook_name);

		if ($cook_hash eq Anvil::User::get_hash($cook_id.":".$cook_email)){
			$Anvil::User::uid = $cook_id;
			$Anvil::User::email = $cook_email;
			$Anvil::User::name = UCW::CGI::rfc822_deescape($cook_name); 
			return;
		}
	}
	#no success - stay anonymous
}

sub
print_logo
{
	my $root = url('index');
	print <<EOF
	<div id="web_img">
	<a href="$root"><img src="$Anvil::Config::web_img" alt="logo" class="logo"></a>
	<span id="web_name">
	<a href="$root" class="logo">$Anvil::Config::web_name</a>
	</span>
	</div>
EOF
;
}

sub 
print_top
{
	my $title = shift;

	print "Content-Type: text/html\n\n";
	print "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
	print "<html>\n";
	print "<head>\n";
	print "<title>$title</title>\n";
	my $files = url('files');
	print qq(<link rel="stylesheet" href="$files/stylesheet.css" media="screen">);
	print "</head>\n";
	print "<body>\n";

	$UCW::CGI::error_hook = sub { print "<h2>".$_[0]."</h2>"; };	
	print "<div class=\"header\">\n";

	print "<div class=\"head-logo\">\n";
	print_logo();
	print "</div>\n";

	print "</div>\n";

	print "<div class=\"bush\">\n";
	print "<div class=\"column\">\n";
	print_login_info();
	print_rss();
	print_blogroll();
	print "</div>\n";

	print "<div class=\"main_content\">\n";


}

sub
print_rss
{
	my $rss = url("rss");
	print <<EOF
<div class="rss">
<a href="$rss">RSS feed</a>
</div>
EOF
;
}

sub
print_blogroll
{
	if ($Anvil::Config::blogroll_show){
        	print "<div id=\"blogroll\">";
		print $Anvil::Config::blogroll_header; 
		for my $blog (@Anvil::Config::blogroll_content){
			print $blog."<br>\n";
		}
	        print "</div>";
	}
}

sub 
print_bottom
{

	print "</div>\n"; #main_content
	print "</div>\n"; #bush
	print "</body>\n";
	print "</html>\n";
}

sub go_404
{

	print "Content-Type: text/html\n";
	print "Status: 404\n\n";
	print "<h1>404: Muhehehehechlemst!</h1>\n";

	print "Muhehehehehechlemst!\n";

	exit;

}

sub url
{
	my $module = shift @_;
	my %args = @_;
	my $url = $Anvil::Config::web_root;
	my $offs = (defined($args{'offset'}) ? $args{'offset'} : $offset);
	my $arti = (defined($args{'art'}) ? $args{'art'} : $art);
	my $nice = $Anvil::Config::web_nice_urls;
	if ($module eq "read" && $arti eq "") {
		$module = "index";
	}
	if ($nice && $module eq "read") {
		$url .= $arti;
	} elsif ($nice && $module eq "index" && $offs) {
		$url .= "index/$offs";
	} elsif ($module eq "index" && !$offs) {
		# Just use the root
	} elsif ($module eq "files") {
		$url .= "files";
	} elsif ($module eq "rss") {
		$url .= "rss.xml";
	} else {
		# login must not be in "action/", otherwise cookies do not work!
		$url .= "action/" if $nice && $module ne "login";
		$url .= "$module.pl";
		my $args = self_ref(@_);
		$url .= $args if $args ne "?";
	}
	if ($args{'absolute'}) {
		$url = 'http://' . $Anvil::Config::web_domain . $url;
	}
	return $url;
}

42;
