package Anvil::User;

use DBI;
use Anvil::DB;
use UCW::CGI;
use MIME::Entity;
use Email::Address;
use Digest::SHA1  qw(sha1 sha1_hex sha1_base64);

our $email;
our $uid;
our $name;

sub
get_hash
{
	my $form_email = shift;
	my $key = $Anvil::Config::secret_key; 

	return sha1_hex($form_email.$key); 
}

sub
send_login_mail
{
	my $form_email = shift;

	my $link = "Kliknutím na tento odkaz se přihlásíte:\n"
		. Anvil::Common::url('login',
				    'hash' => get_hash($form_email),
				    'conf_email' => $form_email,
				    'absolute' => 1)
		. "\n";

	my $ent = MIME::Entity->build(
			From => $Anvil::Config::mail_login_email,
			To => $form_email,
			Subject => "Login: $Anvil::Config::web_domain",
			Charset => 'utf8',
			Data => $link,
		);

	open SEND, "|/usr/lib/sendmail -f $Anvil::Config::mail_login_email $form_email" or die("Cannot open sendmail");
	$ent->print(\*SEND); 
	close SEND;
}

sub
log_in
{
	$email = shift;

	my $dbh = Anvil::DB::get_dbh;

	my $query = "SELECT id, name FROM ".$Anvil::Config::db_prefix."_users WHERE email = '$email'";
	my $sth = $dbh->prepare($query);
	$sth->execute();
	my $result = $sth->fetchrow_hashref();
	$sth->finish;
	if (defined $result){
		$uid = $result->{'id'};
		if (defined $result->{'name'}){
			$name = $result->{'name'};
		} else {
			my ($e) = Email::Address->parse($email);
	                $name = $e->user;
		}
	} else {
		$query = "INSERT INTO ".$Anvil::Config::db_prefix."_users (email) values ('$email')";
		$dbh->do($query);
		$query = "SELECT id FROM ".$Anvil::Config::db_prefix."_users WHERE email = '$email'";
	 	$sth = $dbh->prepare($query);
	 	$sth->execute();
	 	$result = $sth->fetchrow_hashref();
	 	$sth->finish;
		die("Cannot do login") unless defined $result;
		$uid = $result->{'id'};
		my ($e) = Email::Address->parse($email);
		$name = $e->user;
	}

}

42;
