#!/usr/bin/perl -w

use Anvil::Common;
use Anvil::Config;
use Anvil::DB;
use Anvil::Articles;

use UCW::CGI;
use DBI;
use POSIX;

use strict;
use integer;

my $offset = $Anvil::Common::offset;

sub
print_listing
{
	my $n = shift;
	my $last = ($n-10)/10;

	return if ($last < 0);

	print "|";
	for (0..$last) {
		my $of;
		
		if ($_) {
			$of = $last - $_ + 1; 
		} 
		else { 
			$of = 0;
		}

		print " ";
		print "<a href='", Anvil::Common::url('index', 'offset' => $of), "'>" unless ($of == $offset);
		print $_+1;
		print "</a>" unless ($of == $offset);
		print " |";
	}
}

sub
print_content
{
	my $dbh = Anvil::DB::get_dbh;

	my $sth = $dbh->prepare("SELECT COUNT(*) AS cnt FROM " . Anvil::DB::table_name("articles"));
	$sth->execute();
	my $num_articles = $sth->fetchrow_hashref->{'cnt'};
	my $last_article = $num_articles-1;
	$sth->finish();

	my $start_off = 0;

	my $end_off = 10 + ($last_article % 10);
	if ($end_off > $last_article) {
		$end_off = $last_article;
	}

	if ($offset) {
		my $ne = $last_article - (10*($offset-1));
		my $ns = $ne - 9;

		if ($ns >= 0){
			$start_off = $ns;
			$end_off = $ne;
		}
	}

	my @articles = ();
	my $num = $end_off - $start_off + 1;
	$sth = $dbh->prepare("SELECT art FROM " . Anvil::DB::table_name("articles") . " ORDER BY date DESC LIMIT $start_off,$num");
	$sth->execute();
	while (my $r = $sth->fetchrow_hashref) {
		push @articles, $r->{'art'};
	}
	$sth->finish();

	foreach my $art (@articles) {
		my $art_hr = Anvil::Articles::load_article($art);
		print $art_hr->heading;
		print $art_hr->{'abstract'}, "<p>\n" if defined $art_hr->{'abstract'};

		print "<div class=\"cell\">".POSIX::strftime("%d. %m. %Y, %H:%M", localtime $art_hr->{'date'})."</div>";
		print "<div class=\"cell\">Komentářů: ".
			$art_hr->{'comments'}."</div>";
		print "<div class=\"cell\">Nových: ".$art_hr->{'new_comments'}.
			"</div>" if defined $art_hr->{'new_comments'};
		print "<div class=\"cell\"><a href='", Anvil::Common::url('read', 'art' => $art_hr->{'id'}) . "'>Číst dál...</a></div>";
		print "<br>\n";
	}

	$dbh->disconnect();
	
	print_listing($num_articles);
}

Anvil::Common::init();
Anvil::Common::print_top("$Anvil::Config::web_name");

print_content();

Anvil::Common::print_bottom();
