#!/usr/bin/perl -w

use strict;

use Anvil::Common;
use Anvil::DB;
use Anvil::User;
use UCW::CGI;
use Digest::SHA1  qw(sha1 sha1_hex sha1_base64);

sub redir_back {
	print "Status: 302\n";
	print "Location: ", Anvil::Common::url('read', 'absolute' => 1), "\n\n";
}

sub status {
	my $msg = shift @_;
	Anvil::Common::init();
	Anvil::Common::print_top($msg);
	print "<h2>$msg</h2>\n";
	Anvil::Common::print_bottom;
}

if ($Anvil::Common::logout){
	UCW::CGI::set_cookie('astfgl','', 'discard' => undef);
	redir_back();
	exit;
}

if ($Anvil::Common::form_email){
	if ($Anvil::Common::form_password){
		my $dbh = Anvil::DB::get_dbh();
		my $query = "SELECT pass FROM ".Anvil::DB::table_name("users")." WHERE email=?";
		my $sth = $dbh->prepare($query);
		$sth->execute($Anvil::Common::form_email);
		my $res = $sth->fetchrow_hashref();
		if (defined $res->{'pass'} and ($res->{'pass'} eq sha1_hex($Anvil::Common::form_password))){
			Anvil::User::log_in($Anvil::Common::form_email);
			Anvil::Common::set_login_cookie();
			redir_back();
		} else {
			status('Špatné jméno nebo heslo');
		}
	} else {
		Anvil::User::send_login_mail($Anvil::Common::form_email);
		status('Mail odeslán');
	}
	exit;
}

#attempt to login through e-mail link
if (defined $Anvil::Common::hash and ($Anvil::Common::hash eq Anvil::User::get_hash($Anvil::Common::conf_email))){
	Anvil::User::log_in($Anvil::Common::conf_email);
	Anvil::Common::set_login_cookie();
	redir_back();
	exit;
}

status('Chybné parametry');
exit;
