#!/usr/bin/perl -w

use UCW::CGI;
use Email::Address;
use Anvil::Common;
use Anvil::Comments;
use Anvil::Config;
use Anvil::Articles;
use strict;

Anvil::Common::init();

my $art = $Anvil::Common::art or Anvil::Common::go_404;
-r "content/$art" or Anvil::Common::go_404;

my $art_hr = Anvil::Articles::load_article($art);
my $title = "$art_hr->{'title'} - Přidat komentář";

my $reply_to = $Anvil::Common::reply_to;
defined $reply_to or Anvil::Common::go_404;

# FIXME: Read only the relevant comment
my $cmt = Anvil::Comments::get_hash($art);
!$reply_to or exists $cmt->{$reply_to} or Anvil::Common::go_404;

my %checks = %Anvil::Config::cmt_captcha; 
my $uid = $Anvil::User::uid;
my $cque = $Anvil::Common::reply_checkq;
my $cans = $Anvil::Common::reply_checka;
my $err;
my $email = ($uid ? $Anvil::User::email : $Anvil::Common::reply_email);
my $name = ($uid ? $Anvil::User::name : $Anvil::Common::reply_name);
if ($Anvil::Common::reply_action eq "") {
	$err = "";
	if (!$reply_to){
		$Anvil::Common::reply_subject = "Re: ".$art_hr->{'title'};
	} else {
		my $subj = $cmt->{$reply_to}->{'subject'};
		$subj =~ s/^(\s*[Rr][eE]:\s*)*//;
		$Anvil::Common::reply_subject = "Re: ".$subj; 
	}
} elsif ($Anvil::Common::reply_subject =~ /^\s*$/) {
	$err = "Chybí předmět!";
} elsif (!$uid && !exists $checks{$cque}) {
	$err = "To jsou mi ale divné parametry?!";
} elsif (!$uid && $cans !~ ('^' . $checks{$cque} . '$')) {
	$err = "Chybná odpověď na kontrolní otázku, zkuste to prosím znovu.";
	$cque = "";
} elsif (!$uid && $name =~ /^\s*$/) {
	$err = "Podepište se, aspoň třemi křížky";
} elsif (!$uid && $email !~ $Email::Address::addr_spec) {
	$err = "Chybná mailová adresa";
} elsif ($Anvil::Common::reply_text =~ /^(\s|\n)*$/s) {
	$err = "Prázdný příspěvek!";
} elsif ($Anvil::Common::reply_action eq "Náhled") {
	$err = "Náhled příspěvku:";
} else {
	Anvil::Comments::save_comment($art, $name, $Anvil::Common::reply_subject, $reply_to, $email, html_escape($Anvil::Common::reply_text));
	print "Status: 302\n";
	print "Location: ", Anvil::Common::url('read',
		"reply_to" => undef,
		"reply_checkq" => undef,
		"reply_checka" => undef,
		"reply_name" => undef,
		"reply_email" => undef,
		"reply_action" => undef,
		"reply_subject" => undef,
		"reply_text" => undef,
		) . "\n\n";
	exit 0;
}

if (!$uid && $cque eq "") {
	my @ques = keys %checks;
	$cque = $ques[int(rand(@ques))];
	$Anvil::Common::reply_checkq = $cque;
}

Anvil::Common::print_top("$title");

if ($reply_to) {
	print "<h2>Odpověď na příspěvek</h2>\n";
	Anvil::Comments::print_comment($cmt, $reply_to);
} else {
	print "<h2>Nový příspěvek k článku</h2>\n";
}

if ($err ne "") {
	if ($err =~ /!$/) {
		print "<h2>Chyba: $err</h2>\n";
	} elsif ($err ne "") {
		# Preview
		print "<h2>$err</h2>\n";
		$cmt->{'-preview-'} = {
			'id' => '-preview-',
			'art' => $art,
			'subject' => $Anvil::Common::reply_subject,
			'text' => html_escape($Anvil::Common::reply_text),
			'parent' => 0,
			'name' => $name,
			'email' => $email,
			'date' => time(),
		};
		Anvil::Comments::print_comment($cmt, "-preview-");
	}
}

print "<form action='reply.pl' method=POST>\n";
print UCW::CGI::self_form();
print "<table>\n";
print "<tr><td>Předmět:<td><input type=text name='reply_subject' size=64 maxlength=128 value='" . html_escape($Anvil::Common::reply_subject) . "'>\n";
if (!$uid) {
	print "<tr><td>Jméno:<td><input type=text name='reply_name' size=64 maxlength=128 value='" . html_escape($Anvil::Common::reply_name) . "'>\n";
	print "<tr><td>E-mail:<td><input type=text name='reply_email' size=64 maxlength=128 value='" . html_escape($Anvil::Common::reply_email) . "'>\n";
	print "<tr><td>$cque<td><input type=text name='reply_checka' size=64 maxlength=128 value='" . html_escape($Anvil::Common::reply_checka) . "'>\n";
}
print "</table>\n";
print "<p>Text příspěvku:\n";
print "<p><textarea name=reply_text rows=10 cols=80>\n";
print html_escape($Anvil::Common::reply_text);
print "</textarea>\n";
print "<p><input type=submit name=reply_action value='Odeslat'> <input type=submit name=reply_action value='Náhled'>\n";
print "</form>\n";

Anvil::Common::print_bottom;
