#!/usr/bin/perl -w

use strict;

use UCW::CGI;
use Anvil::Common;
use Anvil::Comments;
use Anvil::Articles;

my ($art, $send);
$art = $Anvil::Common::art;
$send = $Anvil::Common::send;

Anvil::Common::go_404 unless $art;
Anvil::Common::go_404 unless -f "content/$art";

my $art_hr = Anvil::Articles::load_article($art);
my $cmt = Anvil::Comments::get_hash($art);

Anvil::Common::init();
send_comment($art, $send, $cmt);

print "Status: 302\n";
print "Location: ", Anvil::Common::url('read', 'absolute' => 1), "\n\n";
exit;

sub
send_comment
{
	my $art = shift;
	my $send = shift;
	my $cmt = shift;
	my ($subject, $text, $id, $type, $references, $reply, $sender_name);
	my @references = ();
	$references = "";
	$reply = "";
	$sender_name = $Anvil::Config::mail_from_name;

	defined $Anvil::User::uid or return;

	if ($send){
		my $dbh = Anvil::DB::get_dbh;
		my $query;
		$query = "SELECT * from ".$Anvil::Config::db_prefix.
			"_comments where id = ".$send.";";

		my $sth = $dbh->prepare($query);
		$sth->execute();
		my $result = $sth->fetchrow_hashref;
		$subject = $result->{'subject'};
		$subject =~ s/\n//mg;
		$id = $result->{'id'};
		$text = Anvil::Comments::html_deescape($result->{'text'});
		$type = 'plain';
		@references = map {s/(\d+)/<$1-$art\@$Anvil::Config::mail_domain>/;$_} @{Anvil::Comments::collect_ref_ids($send, $cmt)};
		$references = join (' ', @references);
		$reply = $references[0];
		if (defined $result->{'name'}){
			$sender_name = $result->{'name'};
		}

} else {
		my $art_hr = Anvil::Articles::load_article($art);
		$text = "<html>\n<title>$art_hr->{'title'}</title>\n<body>\n";
		$text .= $art_hr->heading;
		$text .= $art_hr->inline_abstract;
		$text .= $art_hr->{'text'};
		$text .= "</body>\n</html>\n";
		$id = 0;
		$type = 'html';
		$subject = $art_hr->{'title'};
		$subject =~ s/\n//mg;
	}
	open SEND, "|/usr/lib/sendmail -f $Anvil::Config::mail_from_email $Anvil::User::email" 
			or die("Cannot open sendmail");

	my $ent = MIME::Entity->build( From => "$sender_name <$Anvil::Config::mail_from_email>",
				To => "$Anvil::User::email",
				Subject => MIME::AltWords::encode_mimewords($subject, 'Charset' => 'utf-8'),
				'Message-Id' => "<$id-$art\@$Anvil::Config::mail_domain>",
				'MIME-Version' => '1.0',
				Type => "text/$type",
				Data => $text,
				Charset => 'utf-8',
				Encoding => 'base64',
				References => $references,
				'In-Reply-To:' => $reply,
	);


	$ent->print(\*SEND);
	close SEND;
}
