#!/usr/bin/perl -w

use UCW::CGI;
use Anvil::Common;
use Anvil::User;
use Anvil::DB;
use strict;

sub
save_settings
{
	my $dbh = Anvil::DB::get_dbh();

	my $query = "UPDATE ".$Anvil::Config::db_prefix."_users SET 
	set_allrep='".($Anvil::Common::set_allrep?1:0)."',  
	set_allmy='".($Anvil::Common::set_allmy?1:0)."',
	set_allart='".($Anvil::Common::set_allart?1:0)."',
	set_allnew='".($Anvil::Common::set_allnew?1:0)."',
	name='$Anvil::Common::set_name'
	".
	($Anvil::Common::set_pass
		and $Anvil::Common::set_pass_check 
		and ($Anvil::Common::set_pass eq 
			$Anvil::Common::set_pass_check)
	?
		", pass = SHA1('$Anvil::Common::set_pass')"
	:
		""
	)
	."
	WHERE id=".$Anvil::User::uid.";";

	$dbh->do($query) or die "Cannot save into database";
}

Anvil::Common::init();

#FIXME
if (not defined $Anvil::User::email) {
	print "Status: 302\n"; 
	print "Location: ", Anvil::Common::url('index'), "\n\n";
	exit;
}

#save settings and exit, if possible
if ($Anvil::Common::set_hidden) {
	save_settings();
	$Anvil::User::name = $Anvil::Common::set_name;
	Anvil::Common::set_login_cookie();
	print "Status: 302\n";
	print "Location: ", Anvil::Common::url('index'), "\n\n";
	exit;
}

Anvil::Common::print_top("Nastavení");

my $dbh = Anvil::DB::get_dbh();
my $query = "SELECT set_allrep, set_allmy, set_allnew, set_allart, pass FROM "
	.$Anvil::Config::db_prefix."_users WHERE id=".$Anvil::User::uid.";";
my $sth = $dbh->prepare($query);
$sth->execute();
my $res = $sth->fetchrow_hashref;
my @checked = ($res->{'set_allrep'}, $res->{'set_allmy'}, 
		$res->{'set_allart'}, $res->{'set_allnew'});
@checked = map $_? 'checked' : '', @checked;

print <<EOF
<div class="settings">
<form action="settings.pl" method="POST">

<input type="checkbox" name="set_allrep" $checked[0]> -  Zasílat všechny odpovědi na mé komentáře<br>
<input type="checkbox" name="set_allmy" $checked[1]> -  Zasílat všechny reakce na články, které jsem komentoval<br>
<input type="checkbox" name="set_allart" $checked[2]> - Zasílat všechny nové články<br>
<input type="checkbox" name="set_allnew" $checked[3]> - Zasílat všechny nové komentáře<br>

Jméno: <input type="text" name="set_name" value="$Anvil::User::name"><br>
<p>
Pokud nechcete měnit heslo, nechte prosím prázdné<br>
<table>
<tr>
	<td>Heslo:</td>
	<td><input type="password" name="set_pass" value=""><td>
</tr>
<tr>
	<td>Kontrola:</td>
	<td><input type="password" name="set_pass_check" value=""></td>
</tr>
</table>
<input type="hidden" name="set_hidden" value=1>
<input type="submit" value="Odeslat">
</form>
</div>
EOF
;

Anvil::Common::print_bottom();
