#!/usr/bin/perl -w

use strict;

use MIME::Entity;
use MIME::AltWords;

use Anvil::Config;
use Anvil::DB;
use Anvil::Articles;

use UCW::CGI;

my $art = $ARGV[0] or die "Usage: $0 <file>\n";
$art =~ s{^content/}{};
-f "content/$art" or die "Unknown article $art\n";

my $art_hr = Anvil::Articles::load_article($art);
my $text = "<html>\n<title>$art_hr->{'title'}</title>\n";
$text .= "<base href='".Anvil::Common::url('read', 'art' => $art, 'absolute' => 1)."'>\n";
$text .= "<body>\n";
$text .= $art_hr->heading;
$text .= $art_hr->inline_abstract;
$text .= $art_hr->{'text'};
$text .= "</body>\n</html>\n";
my $id = 0;
my $subject = $art_hr->{'title'};
$subject =~ s/\n//mg;

my @receivers = ();
my $dbh = Anvil::DB::get_dbh;
my $query = "SELECT email FROM ".$Anvil::Config::db_prefix."_users WHERE
	set_allart = 1;"; 
my $sth = $dbh->prepare($query);
$sth->execute();
while (my $result = $sth->fetchrow_hashref){
	push @receivers, $result->{'email'}; 
}
my $recipients = join " ", @receivers;

exit unless $recipients;
open SEND, "|/usr/lib/sendmail -f $Anvil::Config::mail_from_email $recipients"
                        or die("Cannot open sendmail");

my $ent = MIME::Entity->build( From => "$Anvil::Config::mail_from_name <$Anvil::Config::mail_from_email>",
                                Subject => MIME::AltWords::encode_mimewords($subject, 'Charset' => 'utf-8'),
                                'Message-Id' => "<0-$art\@$Anvil::Config::mail_domain>",
                                'MIME-Version' => '1.0',
                                Type => "text/html",
                                Data => $text,
                                Charset => 'utf-8',
                                Encoding => 'base64',
        );


$ent->print(\*SEND);
close SEND;
